<?php
if ( ! function_exists( 'add_action' ) ) {
	echo "Hi there!  I'm just a plugin, not much I can do when called directly.";
	exit;
}

//require_once( "jpibfi-validation.php" );
//require_once( "jpibfi-constants.php" );

function jpibfi_conditional( $condition, $true_value = "", $false_value = "", $echo = true) {
	if ( $condition ) {
		if ( $echo )
			echo $true_value;
		return $true_value;
	}
	if ( $echo )
		echo $false_value;
	return $false_value;
}

//Prints out the admin page
function jpibfi_print_admin_page() {
	global $jpibfi_button_dropdown;
	global $jpibfi_button_css;

	$dev_options          = jpibfi_get_basic_options();
	$advanced_dev_options = jpibfi_get_advanced_options();
	$custom_button_css = jpibfi_get_button_css();
	$errors = array(
		'disabled_classes' => false,
		'enabled_classes' => false,
		'custom_image_height' => false,
		'custom_image_width' => false,
		'transparency_value' => false,
		'min_image_height' => false,
		'min_image_width' => false
	);
	?>

	<div class="wrap" id="top_anchor">
		<h2>jQuery Pin It Button For Images</h2>

	<?php

	if ( isset( $_POST['update_jQuery_Pin_It_Button_For_Images'] ) ) {
		//security check
		if ( ! wp_verify_nonce( $_POST['jpibfi_nonce'], 'jpibfi_admin_settings' ) )
			die( 'Security alert' );

		$errors['disabled_classes'] = ! jpibfi_contains_css_class_names_or_empty( $_POST['disabled_classes'] );
		$errors['enabled_classes'] = ! jpibfi_contains_css_class_names_or_empty( $_POST['enabled_classes'] );
		$errors['custom_image_height'] = ! jpibfi_is_numeric_and_more_or_equal_to_zero( $_POST['custom_image_height'] );
		$errors['custom_image_width'] = ! jpibfi_is_numeric_and_more_or_equal_to_zero( $_POST['custom_image_width'] );
		$errors['min_image_height'] = ! jpibfi_is_numeric_and_more_or_equal_to_zero( $_POST['min_image_height'] );
		$errors['min_image_width'] = ! jpibfi_is_numeric_and_more_or_equal_to_zero( $_POST['min_image_width'] );

		//rewrite settings that came from the POST request
		$dev_options['image_selector']     = sanitize_text_field( $_POST['image_selector'] );
		$dev_options['compatibility_mode'] = $_POST['compatibility_mode'] == '1' ? '1' : '0';
		$dev_options['transparency_value'] =
				$dev_options['compatibility_mode'] == '0' ? $_POST['standard_transparency'] : $_POST['compatibility_transparency'];
		$dev_options['disabled_classes']   = $_POST['disabled_classes'];
		$dev_options['enabled_classes']    = $_POST['enabled_classes'];
		$dev_options['description_option'] = $_POST['description_option'];
		$dev_options['min_image_height'] = $_POST['min_image_height'];
		$dev_options['min_image_width'] = $_POST['min_image_width'];
		$dev_options['use_custom_image']    = isset( $_POST['use_custom_image'] )? "1" : "0";

		$dev_options['custom_image_url']    = $_POST['custom_image_url'];
		$dev_options['custom_image_height'] = $_POST['custom_image_height'];
		$dev_options['custom_image_width']  = $_POST['custom_image_width'];

		$dev_options['use_post_url']    = isset( $_POST['use_post_url'] ) ? "1" : "0";
		$dev_options['button_position']    = $_POST['button_position'];

		if ( $dev_options['compatibility_mode'] == '0' )
				$errors['transparency_value'] = ! is_numeric( $dev_options['transparency_value'] ) || ( $dev_options['transparency_value'] < 0.0 ) || ( $dev_options['transparency_value'] > 1.0 );

		$advanced_dev_options['on_home']     = isset( $_POST['on_home'] ) ? '1' : '0';
		$advanced_dev_options['on_page']     = isset( $_POST['on_page'] ) ? '1' : '0';
		$advanced_dev_options['on_single']   = isset( $_POST['on_single'] )  ? '1' : '0';
		$advanced_dev_options['on_category'] = isset( $_POST['on_category'] ) ? '1' : '0';
		$advanced_dev_options['on_blog'] = isset( $_POST['on_blog'] ) ? '1' : '0';

		// 5 means we need to use custom CSS
		if ( "5" == $dev_options['button_position'] )
			$custom_button_css = $_POST['custom_button_css'];
		else
			$custom_button_css = $jpibfi_button_css[$dev_options['button_position']];

		$any_errors = false;
		foreach ( $errors as $value )
			$any_errors = $any_errors || $value;

		if ( ! $any_errors ) { //save only if there are no errors
			update_option( JPIBFI_BASIC_OPTIONS, $dev_options );
			update_option( JPIBFI_ADVANCED_OPTIONS, $advanced_dev_options );
			update_option( JPIBFI_BUTTON_CUSTOM_CSS, $custom_button_css );
			//delete_option( JPIBFI_BUTTON_CUSTOM_CSS );

			?>
		<p class='jpibfi-success-message'><?php _e( "Settings Updated.", "jpibfi" );?></p>
		<?php
		}
		else { //otherwise inform that there are some errors
			?>
		<p class='jpibfi-error-message'><?php _e( "Error. Settings not updated. Look for details below.", "jpibfi" ); ?></p>
		<?php
		}
	}
?>
	<div id="errors_div">
		<div id="disabled_classes_error" class="<?php jpibfi_conditional( $errors["disabled_classes"], "jpibfi-visible", "jpibfi-hidden" ); ?>">
			Disabled classes setting error. Please change it and try submitting again.
		</div>
		<div id="enabled_classes_error" class="<?php jpibfi_conditional( $errors["enabled_classes"], "jpibfi-visible", "jpibfi-hidden" ); ?>">
			Enabled classes setting error. Please change it and try submitting again.
		</div>
		<div id="standard_transparency_error" class="<?php jpibfi_conditional( $errors["transparency_value"], "jpibfi-visible", "jpibfi-hidden" ); ?>">
			The given transparency error is not valid. Please change the value and try submitting again.
		</div>
		<div id="custom_image_height_error" class="<?php jpibfi_conditional( $errors["custom_image_height"], "jpibfi-visible", "jpibfi-hidden" ); ?>">
			Custom image height must be a number larger than or equal to zero.
		</div>
		<div id="custom_image_width_error" class="<?php jpibfi_conditional( $errors["custom_image_width"], "jpibfi-visible", "jpibfi-hidden" ); ?>">
			Custom image width must be a number larger than or equal to zero.
		</div>
		<div id="min_image_height_error" class="<?php jpibfi_conditional( $errors["min_image_height"], "jpibfi-visible", "jpibfi-hidden" ); ?>">
			Minimum image height must be a number larger than or equal to zero.
		</div>
		<div id="min_image_width_error" class="<?php jpibfi_conditional( $errors["min_image_width"], "jpibfi-visible", "jpibfi-hidden" ); ?>">
			Minimum image width must be a number larger than or equal to zero.
		</div>
	</div>

	<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
		<?php wp_nonce_field( "jpibfi_admin_settings", 'jpibfi_nonce' ); ?>
		<h3>Which images can be pinned</h3>
		<hr/>

		<table class="settings-table">
			<tbody>
			<tr>
				<th scope="row"><label for="image_selector">Image selector</label></th>
				<td>
					<input type="text" id="image_selector" name="image_selector"
								 value="<?php echo esc_attr( $dev_options['image_selector'] );?>" />

					<p class="description">jQuery selector for all the images that should have the "Pin it" button. Set
						the value to <a href="#" class="jpibfi_selector_option">div.jpibfi_container img</a> if you want
						the "Pin it" button to appear only on images in content or <a href="#" class="jpibfi_selector_option">img</a>
						to appear on all images on site (including sidebar, header and footer). If you know a thing or two about jQuery, you might use your own selector.
						<a href="http://api.jquery.com/category/selectors/" target="_blank">Click here</a> to read
						about jQuery selectors.</p>
				</td>
			</tr>
			<tr>
				<th scope="row"><label for="disabled_classes">Disabled classes</label></th>
				<td>
					<textarea id="disabled_classes"	name="disabled_classes" <?php jpibfi_conditional( $errors["disabled_classes"], "class='error-border'" ); ?>
							><?php echo esc_attr( $dev_options['disabled_classes'] );?></textarea>

					<p class="description">Pictures with these CSS classes won't show the "Pin it" button. Please separate multiple classes with semicolons. Spaces are not accepted.</p>
				</td>
			</tr>
			<tr>
				<th scope="row"><label for="enabled_classes">Enabled classes</label></th>
				<td>
					<textarea id="enabled_classes" name="enabled_classes" <?php jpibfi_conditional( $errors["enabled_classes"], "class='error-border'" ); ?>
							><?php echo esc_attr( $dev_options['enabled_classes'] );?></textarea>
					<p class="description">Pictures with these CSS classes will show the "Pin it" button. Please
						separate multiple classes with semicolons. If this field is empty, images with any (besides
						disabled ones) classes will show the Pin It button.</p>
				</td>
			</tr>
			<tr>
				<th scope="row"><label>On which pages the "Pin it" button should be shown</label></th>
				<td>
					<input type="checkbox" id="on_home" name="on_home" <?php checked( "1", $advanced_dev_options['on_home'] ); ?> value="1" />
					<label for="on_home"> Home page</label><br />
					<input type="checkbox" id="on_page" name="on_page" <?php checked( "1", $advanced_dev_options['on_page'] ); ?> value="1" />
					<label for="on_page"> Pages</label><br />
					<input type="checkbox" id="on_single" name="on_single" <?php checked( "1", $advanced_dev_options['on_single'] ); ?> value="1" />
					<label for="on_single"> Single posts</label><br />
					<input type="checkbox" id="on_category"	name="on_category" <?php checked( "1", $advanced_dev_options['on_category'] ); ?> value="1" />
					<label for="on_category"> Category and archive pages</label><br />
					<input type="checkbox" id="on_blog"	name="on_blog" <?php checked( "1", $advanced_dev_options['on_blog'] ); ?> value="1" />
					<label for="on_blog"> Blog pages</label>

					<p class="description">Check on which pages you want the Pinterest button to show up.</p>
				</td>
			</tr>
			<tr>
				<th scope="row"><label>Minimum resolution that should trigger the "Pin it" button to show up</label></th>
				<td>
					<p>
						<label for="min_image_height">Height</label>
						<input type="number" min="0" step="1" id="min_image_height" name="min_image_height" value="<?php echo $dev_options["min_image_height"]; ?>"
									 class="jpibfi-admin-number <?php jpibfi_conditional( $errors['min_image_height'], "error-border"); ?>" /> px
					</p>

					<p>
						<label for="min_image_width">Width</label>
						<input type="number" min="0" step="1" id="min_image_width" name="min_image_width" value="<?php echo $dev_options["min_image_width"]; ?>"
									 class="jpibfi-admin-number <?php jpibfi_conditional( $errors['min_image_width'], "error-border" ); ?>"  /> px
					</p>
					<p class="description">If you'd like the "Pin it" button to not show up on small images (e.g. social media icons), just set the appropriate values above. The default value (0,0) causes the "Pin it" button to show on every eligible image.</p>
				</td>
			</tr>
			</tbody>
		</table>
		<h3>Visual settings</h3>
		<hr/>
		<table class="settings-table">
			<tbody>
			<tr>
				<th scope="row"><label for="description_option">Description source</label></th>
				<td>
					<select id="description_option" name="description_option">
						<option value="1" <?php selected ( "1", $dev_options['description_option'] ); ?>>Page title</option>
						<option value="2" <?php selected ( "2", $dev_options['description_option'] ); ?>>Page description</option>
						<option value="3" <?php selected ( "3", $dev_options['description_option'] ); ?>>Picture title or (if title not available) alt attribute</option>
						<option value="4" <?php selected ( "4", $dev_options['description_option'] ); ?>>Site title (Settings->General)</option>
					</select>

					<p class="description">From where the Pinterest message should be taken.</p>
				</td>
			</tr>
			<tr>
				<th scope="row"><label for="use_post_url">Linked page</label></th>
				<td>
					<input type="checkbox" id="use_post_url" name="use_post_url" value="1" <?php checked( "1", $dev_options["use_post_url"] ); ?> />
					<label class="chbox-label" for="use_post_url">Always link to individual post page</label>
					<p class="description">Experimental feature. When checked, the link on Pinterest will always point to the individual page with the image, even when the image was pinned on an archive page, category page or homepage. If false, the link will point to the URL the user is currently on.</p>
				</td>
			</tr>
			<tr>
				<th scope="row"><label for="compatibility_mode">Transparency</label></th>
				<td>
					<select name="compatibility_mode" id="compatibility_mode">
						<option value="0" <?php selected( "0", $dev_options['compatibility_mode'] ); ?>>Standard mode</option>
						<option value="1" <?php selected( "1", $dev_options['compatibility_mode'] ); ?>>IE7 Compatibility mode</option>
					</select>

					<p id="standard_mode_transparency" <?php echo jpibfi_conditional( "1" == $dev_options['compatibility_mode'], "style='display:none'" );?>>
						<label for="standard_transparency">Choose transparency (between 0.00 and 1.00)</label><br />
						<input type="number" min="0" max="1" step="0.01" id="standard_transparency" name="standard_transparency"
									 value="<?php echo $dev_options['transparency_value'];?>" <?php jpibfi_conditional( $errors["transparency_value"], "class='error-border'" ); ?>/>
					</p>

					<p id="compatibility_mode_transparency" <?php jpibfi_conditional( "0" == $dev_options['compatibility_mode'], "style='display:none'" ); ?>>
						<label for="compatibility_transparency">Choose transparency</label><br />
						<select name="compatibility_transparency" id="compatibility_transparency">
							<?php for ( $i = 0; $i <= 1; $i += 0.1 ): ?>
								<option value="<?php echo $i;?>" <?php selected( round( $i, 1 ), round( $dev_options['transparency_value'], 1 ) ); ?>>
									<?php echo $i;?>
								</option>
							<?php endfor; ?>
						</select>
					</p>
					<p class="description">If you want the plugin to work properly on IE7, meaning the image will become
						transparent on hover, you need to use IE7 Compatibility mode.</p>
				</td>
			</tr>
			<tr>
				<th scope="row"><label>Custom "Pin It" button</label></th>
				<td>
					<p>
						<input type="checkbox" id="use_custom_image" name="use_custom_image" value="1" <?php checked( "1", $dev_options["use_custom_image"] ); ?> />
						<label class="chbox-label" for="use_custom_image">Use custom image</label>
					</p>

					<input id="upload-image" type='button' class='button' value='Upload an image using media library' /><br />

					<p>
						<label for="custom_image_url">URL address of the image</label>
						<input type="url" id="custom_image_url" name="custom_image_url" value="<?php echo $dev_options["custom_image_url"]; ?>" style="width: 100%;" />
					</p>

					<p>
						<label for="custom_image_height">Height</label>
						<input type="number" min="0" step="1" id="custom_image_height" name="custom_image_height" value="<?php echo $dev_options["custom_image_height"]; ?>"
								 class="jpibfi-admin-number <?php jpibfi_conditional( $errors['custom_image_height'], "error-border"); ?>" /> px
					</p>

					<p>
						<label for="custom_image_width">Width</label>
						<input type="number" min="0" step="1" id="custom_image_width" name="custom_image_width" value="<?php echo $dev_options["custom_image_width"]; ?>"
								class="jpibfi-admin-number <?php jpibfi_conditional( $errors['custom_image_width'], "error-border" ); ?>"  /> px
					</p>

					<p class="description">
						Check the <b>Use custom image</b> checkbox, specify image's URL, height and width to use your own Pinterest button design. You can just upload an image using Wordpress media library if you wish.
					</p>
				</td>
			</tr>
			<tr>
				<th scope="row"><label for="button_position">Pin it button position</label></th>
				<td>
					<select name="button_position" id="button_position">
						<?php foreach( $jpibfi_button_dropdown as $key => $value ) { ?>
							<option value="<?php echo $key; ?>" <?php selected( $key, $dev_options['button_position'] ); ?>><?php echo $value; ?></option>
						<?php } ?>
					</select><br/>
					<textarea id="custom_button_css" rows="5" name="custom_button_css"><?php echo $custom_button_css; ?></textarea>

				</td>
			</tr>
			<tr>
				<th scope="row"><label>Preview</label></th>
				<td>
					<img src="<?php echo plugins_url( '/images/image_preview.jpg', __FILE__ ); ?>" id="<?php echo JPIBFI_PREVIEW_IMAGE_ID; ?>"
							alt="This is a preview"/>
					<p class="description">Make sure you reload the settings page (click the proper link in Settings section) once again after saving the settings to make preview work properly.</p>
				</td>
			</tr>
			<tr>
				<th scope="row"><label>Donate</label></th>
				<td>
					<a href="http://bit.ly/Uw2mEP" target="_blank" rel="nofollow" class="button"><b>Donate</b></a>
					<p class="description">If you like the plugin and would like to support its author, please donate.</p>
				</td>
			</tr>
			<tr>
				<th scope="row"></th>
				<td>
					<?php submit_button( null, 'primary', "update_jQuery_Pin_It_Button_For_Images", true, array( 'id' => 'submit_form' ) ); ?>
				</td>
			</tr>
			</tbody>
		</table>
	</form>
</div>
<?php
}
?>